# Deferred

Deferred lets you work with values that haven't been determined yet, like an array that's coming later (one day!) from a web service call. It was originally inspired by [OCaml's Deferred](https://ocaml.janestreet.com/ocaml-core/111.25.00/doc/async_kernel/#Deferred) library.

Deferred is a "futures library", probably like ones you've already heard about. Where Deferred aims to be different is by providing a small, efficient API that's easily adopted in our many [consulting projects](https://www.bignerdranch.com/work).

## Vital Statistics

|                                                                                                        |
|--------------------------------------------------------------------------------------------------------|
|[![Swift 3.x](https://img.shields.io/badge/swift-4.x-EF5138.svg)][Swift]                                |
|[![Under MIT License](https://img.shields.io/badge/license-MIT-blue.svg)][MIT]                          |
|![Multiplatform](https://img.shields.io/badge/platforms-macOS,_iOS,_watchOS,_tvOS,_Linux-lightgrey.svg) |
|[![Travis CI](https://img.shields.io/travis/bignerdranch/Deferred.svg)][CI]                             |
|[![CocoaPods](https://img.shields.io/cocoapods/v/BNRDeferred.svg)][CocoaPods]                           |
|[![Swift Package Manager](https://img.shields.io/badge/swiftpm-supported-orange.svg)][SwiftPM]          |

[Swift]: https://swift.org
[MIT]: https://github.com/bignerdranch/Deferred/blob/master/LICENSE.txt
[CI]: http://travis-ci.org/bignerdranch/Deferred
[CocoaPods]: https://cocoapods.org/pods/BNRDeferred
[SwiftPM]: https://github.com/apple/swift-package-manager

## Don't Panic!

See Deferred's comprehensive programming guide and documentation at the [Deferred Reference](https://bignerdranch.github.io/Deferred/).

If you have a question not answered by the guide or the module comments, please open an issue!

## Need Some Help?

Deferred, as an open source project, is free to use and always will be. [Big Nerd Ranch](https://bignerdranch.com/) offers help for Deferred, Code Audits, and general mobile app design/development services. Email us at [sales@bignerdranch.com](mailto:sales@bignerdranch.com) to get in touch with us for more details.
